%%
%% This is file `monthly.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% monthly.dtx  (with options: `class')
%% This file is part of the Calendar package,
%% Copyright (C) 1996 Frank Bennett, Jr.
%% All rights reserved.
%% ------------------------------------------
%% Everything in this package is provided for demonstration
%% purposes; feel free to edit it in any way whatsoever.
%% ------------------------------------------
%% 

\NeedsTeXFormat{LaTeX2e}[1995/06/01]
\ProvidesClass{monthly}
          [1997/03/01 v1.1 Monthly Calendar (Frank Bennett)]
\LoadClass[oneside]{article}
\newlength\mon@leftspace
\newlength\mon@rightspace
\newlength\mon@tablewidth
\DeclareOption{a5paper}{\OptionNotUsed}
\DeclareOption{b5paper}{\OptionNotUsed}
\DeclareOption{letterpaper}{\OptionNotUsed}
\DeclareOption{legalpaper}{\OptionNotUsed}
\DeclareOption{executivepaper}{\OptionNotUsed}
\DeclareOption{landscape}{\OptionNotUsed}
\DeclareOption{twoside}{\OptionNotUsed}
\DeclareOption{titlepage}{\OptionNotUsed}
\DeclareOption{onecolumn}{\OptionNotUsed}
\DeclareOption{10pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{11pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{12pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{a4paper}
   {\setlength\paperheight {297mm}%
    \setlength\paperwidth  {210mm}%
    \def\mon@titletype#1{{\large\textbf{#1}}}%
    \def\mon@headtype#1{{\textbf{#1}}}%
    \def\mon@datetype#1{\textbf{#1}}
    \def\mon@smalltype#1{{\tiny#1}}}
\DeclareOption{a2paper}
   {\setlength\paperheight {420mm}%
    \setlength\paperwidth  {297mm}%
    \def\mon@titletype#1{{\Huge\textbf{#1}}}%
    \def\mon@headtype#1{{\Large\textbf{#1}}}%
    \def\mon@datetype#1{\Large\textbf{#1}}
    \def\mon@smalltype#1{{\small#1}}}
\DeclareOption{b4paper}
   {\setlength\paperheight {354mm}%
    \setlength\paperwidth  {250mm}%
    \def\mon@titletype#1{{\Huge\textbf{#1}}}%
    \def\mon@headtype#1{{\Large\textbf{#1}}}%
    \def\mon@datetype#1{\Large\textbf{#1}}
    \def\mon@smalltype#1{{\small#1}}}
\ExecuteOptions{a4paper}
\ProcessOptions
\RequirePackage{array}[1996/06/14]
\RequirePackage{calendar}
\RequirePackage{lscape}
\IfFileExists{mygoth.sty}{\RequirePackage{mygoth}}{\let\textgoth\relax}
\setlength{\textheight}{\paperheight}
\setlength{\headheight}{0pt}
\setlength{\headsep}{0pt}
\setlength{\topmargin}{-0.7in}
\setlength{\textwidth}{\paperwidth}
\addtolength{\textheight}{-0.6in}
\addtolength{\textheight}{-4pt}
\setlength{\marginparwidth}{0pt}
\setlength{\marginparsep}{0pt}
\setlength{\oddsidemargin}{-0.7in}
\addtolength{\textwidth}{-0.6in}
\define@key{cal@options}{leftspace}{\setlength{\mon@leftspace}{#1}}
\define@key{cal@options}{rightspace}{\setlength{\mon@rightspace}{#1}}
\define@key{cal@options}{width}{\setlength{\mon@tablewidth}{#1}}
\define@key{cal@options}{title}{\def\mon@title{#1}}
\define@key{cal@options}{firstday}{}
\def\mon@title{\themonth\space\theyear}
\setlength{\mon@tablewidth}{\textheight}
\setlength{\mon@leftspace}{\fill}
\setlength{\mon@rightspace}{\fill}
\pagestyle{empty}
\newlength{\mon@vh}
\newlength{\mon@hw}
\newlength{\mon@templen}
\newlength{\mon@heightlessboxes}
\newlength{\mon@widthlessboxes}
\newcalendar%
{monthly}
{\cal@insert}
{0}
{\dates@days}
{7}
{&}
{I}
{\begin{landscape}%
  \noindent\begin{tabular}{|c|c|c|c|c|c|c|}\hline%
    \multicolumn{7}{|c|}{\mon@titletype{%
      \mon@title}}\\\hline\hline%
    \mon@headtype{Sunday} & \mon@headtype{Monday} &
    \mon@headtype{Tuesday} &
    \mon@headtype{Wednesday} &
    \mon@headtype{Thursday} &
    \mon@headtype{Friday} &
    \mon@headtype{Saturday}\\\hline}
{\\\hline\end{tabular}%
  \end{landscape}}%
{\cal@footer\newpage\cal@header}
{\\\hline}
{\dates@requiremonthtrue}
{\dates@day=1%
  \dates@fix%
  \caldate%
  \cal@range@start\dates@date%
  \message{^^JStart: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@day\dates@days%
  \dates@fix%
  \caldate%
  \cal@range@end\dates@date%
  \message{^^JEnd: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@date=\cal@range@start%
  \caldate%
  \settoheight{\mon@templen}{\mon@titletype{\the\dates@monthname}}%
  \setlength{\mon@heightlessboxes}{\mon@templen}%
  \settodepth{\mon@templen}{\mon@titletype{\the\dates@monthname}}%
  \addtolength{\mon@heightlessboxes}{\mon@templen}%
  \settoheight{\mon@templen}{\mon@headtype{Monday}}%
  \addtolength{\mon@heightlessboxes}{\mon@templen}%
  \settodepth{\mon@templen}{\mon@headtype{Monday}}%
  \addtolength{\mon@heightlessboxes}{\mon@templen}%
  \setlength{\extrarowheight}{3pt}%
  \addtolength{\mon@heightlessboxes}{10\arrayrulewidth}%
  \addtolength{\mon@heightlessboxes}{\doublerulesep}%
  \addtolength{\mon@heightlessboxes}{3pt}%
  \addtolength{\mon@heightlessboxes}{2\lineskip}%
  \addtolength{\mon@heightlessboxes}{2\baselineskip}%
  \setlength{\mon@vh}{\textwidth}%
  \addtolength{\mon@vh}{-\mon@heightlessboxes}%
  \divide\mon@vh by6%
  \setlength{\mon@widthlessboxes}{8\arrayrulewidth}%
  \setlength{\mon@hw}{\mon@tablewidth}%
  \addtolength{\mon@hw}{-\mon@widthlessboxes}%
  \addtolength{\mon@hw}{-14\tabcolsep}%
  \divide\mon@hw by7\relax}
{\newline}%
{\cal@get@appointments\cal@get@events}%
{\relax%
   \ifnum\dates@time@start>0\relax%
    \ifnum\dates@time@start=\dates@time@end%
      \protected@edef\cal@entry@text{%
        \thetimestart\space%
        \cal@textcolor{\calcolor}{\theshorttext}}%
    \else%
      \protected@edef\cal@entry@text{%
        \thetimestart--\thetimeend\space%
        \cal@textcolor{\calcolor}{\theshorttext}}%
    \fi%
  \else%
      \protected@edef\cal@entry@text{%
        \cal@textcolor{\calcolor}{\theshorttext}}%
  \fi}%
{\vbox to\mon@vh{%
    \vskip\medskipamount%
    \hbox{\parbox{\mon@hw}{%
      \mon@datetype{\theday}}}%
       \ifcat$\theevents$%
       \else%
        \vskip\smallskipamount%
        \hbox{\parbox{\mon@hw}{%
          \mon@smalltype{\theevents}}}%
       \fi%
       \ifcat$\theappointments$%
       \else%
        \vskip\smallskipamount%
        \hbox{\parbox{\mon@hw}{%
          \mon@smalltype{\theappointments}}}%
       \fi%
 \vfil}}%
\endinput
%%
%% End of file `monthly.cls'.
