%%
%% This is file `timesht.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% timesht.dtx  (with options: `class')
%% This file is part of the Calendar package,
%% Copyright (C) 1996-1997 by Frank Bennett, Jr.
%% All rights reserved.
%% ------------------------------------------
\NeedsTeXFormat{LaTeX2e}[1995/06/01]
\ProvidesClass{timesht}
          [1997/02/20 v1.0 Monthly calendar (Frank Bennett)]
\LoadClass[oneside]{article}
\newif\iftms@landscape
\newlength\tms@tablewidth
\newlength{\tms@hw}
\newlength{\tms@templen}
\newlength{\tms@widthlessboxes}
\newlength{\tms@timetextlen}
\newtoks\tms@tempreg@a
\newtoks\tms@tempreg@b
\newcount\tms@tempcount
\newcount\tms@start
\newcount\tms@end
\newcount\tms@minuteblocks
\newcount\tms@boxes
\newcount\tms@days
\newcount\tms@blocks
\newcount\tms@time@start
\newcount\tms@time@end
\newcount\tms@hours@start
\newcount\tms@minutes@start
\newcount\tms@hours@end
\newcount\tms@minutes@end
\newcount\tms@minute@base
\newlength{\tms@numlen}
\newcount\tms@rightprop
\newcount\tms@leftprop
\newcount\tms@groupblocks
\newcount\tms@groupblockcount
\tms@groupblockcount=1%
\newlength{\tms@colonlen}
\newlength{\tms@dashlen}
\newlength{\tms@leftlen}
\newlength{\tms@rightlen}
\tms@leftprop=1%
\tms@rightprop=1%
\DeclareOption{a5paper}{\OptionNotUsed}
\DeclareOption{b5paper}{\OptionNotUsed}
\DeclareOption{legalpaper}{\OptionNotUsed}
\DeclareOption{executivepaper}{\OptionNotUsed}
\DeclareOption{twoside}{\OptionNotUsed}
\DeclareOption{titlepage}{\OptionNotUsed}
\DeclareOption{onecolumn}{\OptionNotUsed}
\DeclareOption{10pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{11pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{12pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{letterpaper}
   {\setlength\paperheight{11in}%
    \setlength\paperwidth{8.5in}%
    \def\tms@titletype#1{{\Large\textbf{#1}}}%
    \def\tms@labeltype#1{{\large\textbf{#1}}}%
    \def\tms@timelabeltype#1{\textbf{#1}}
    \def\tms@timeitemtype#1{{\large#1}}
    \def\tms@itemtype#1{{\small#1}}}
\DeclareOption{a4paper}
   {\setlength\paperheight{297mm}%
    \setlength\paperwidth{210mm}%
    \def\tms@titletype#1{{\Large\textbf{#1}}}%
    \def\tms@labeltype#1{{\large\textbf{#1}}}%
    \def\tms@timelabeltype#1{\textbf{#1}}
    \def\tms@timeitemtype#1{{\large#1}}
    \def\tms@itemtype#1{{\small#1}}}
\DeclareOption{a2paper}
   {\setlength\paperheight {420mm}%
    \setlength\paperwidth  {297mm}%
    \def\tms@titletype#1{{\Huge\textbf{#1}}}%
    \def\tms@labeltype#1{{\Large\textbf{#1}}}%
    \def\tms@timelabeltype#1{\large\textbf{#1}}
    \def\tms@timeitemtype#1{{\Large#1}}
    \def\tms@itemtype#1{#1}}
\DeclareOption{b4paper}
   {\setlength\paperheight{354mm}%
    \setlength\paperwidth{250mm}%
    \def\tms@titletype#1{{\Huge\textbf{#1}}}%
    \def\tms@labeltype#1{{\Large\textbf{#1}}}%
    \def\tms@timelabeltype#1{\large\textbf{#1}}
    \def\tms@timeitemtype#1{{\Large#1}}
    \def\tms@itemtype#1{#1}}
\DeclareOption{landscape}{\tms@landscapetrue}
\ExecuteOptions{a4paper}
\ProcessOptions
\pagestyle{empty}
\setlength{\headheight}{0pt}
\setlength{\headsep}{0pt}
\setlength{\topmargin}{-0.4in}
\setlength{\textheight}{\paperheight}
\addtolength{\textheight}{-1.2in}
\setlength{\marginparwidth}{0pt}
\setlength{\marginparsep}{0pt}
\setlength{\oddsidemargin}{-0.4in}
\setlength{\textwidth}{\paperwidth}
\addtolength{\textwidth}{-1.2in}
\iftms@landscape
  \setlength{\tms@tablewidth}{\textheight}%
\else
  \setlength{\tms@tablewidth}{\textwidth}%
\fi
\RequirePackage{longtable}
\RequirePackage{array}[1996/06/14]
\RequirePackage{rotating}
\RequirePackage{calendar}
\RequirePackage{keyval}
\RequirePackage{lscape}
\tracingdates=0%
\define@key{cal@options}{leftspace}{\setlength{\LTleft}{#1}}
\define@key{cal@options}{rightspace}{\setlength{\LTright}{#1}}
\define@key{cal@options}{width}{\setlength{\tms@tablewidth}{#1}}
\define@key{cal@options}{title}{\def\tms@title{#1}}
\define@key{cal@options}{start}{\@settime\tms@start#1{}}
\define@key{cal@options}{end}{\@settime\tms@end#1{}}
\define@key{cal@options}{blockminutes}{\tms@minuteblocks=#1}
\define@key{cal@options}{blockgroup}{\tms@groupblocks=#1}
\define@key{cal@options}{leftright}{\tms@extractprops#1{}}
\def\tms@extractprops#1/#2#{%
  \tms@leftprop=#1\tms@rightprop=#2}
\def\@settime#1#2:#3#{%
  \tms@tempcount=#2%
  \multiply\tms@tempcount by60%
  \advance\tms@tempcount by#3%
  \global#1\tms@tempcount}
\def\@splitblocks#1-#2#{%
  \def\@blockstarttext{#1}%
  \def\@blockendtext{#2}}
\def\@setblocks#1,#2#{%
  \ifcat$#1$%
    \let\next\@gobble%
  \else%
    \let\next\@setblocks%
    \global\advance\tms@blocks by 1%
    \@splitblocks#1{}%
    \expandafter\@settime%
      \expandafter\tms@time@start\@blockstarttext{}%
    \expandafter\@settime%
      \expandafter\tms@time@end\@blockendtext{}%
    \let\tms@tempmac\tms@blocklist%
    \edef\tms@blocklist{%
      \tms@tempmac\the\tms@time@start-\the\tms@time@end,}%
  \fi%
    \next#2{}}
\def\tms@chopblock#1-#2,#3#{%
  \global\tms@time@start=#1%
  \global\tms@time@end=#2%
  \gdef\tms@blocklist{#3}}%
\def\tms@labellist{}%
\def\@extractlabels#1,#2#{%
  \ifcat$#1$%
    \tms@tempreg@a=\expandafter{\tms@labellist}%
    \edef\tms@label##1{%
      \noexpand\ifcase##1\the\tms@tempreg@a\noexpand\fi}%
    \let\next\@gobble%
  \else%
    \let\next\@extractlabels%
    \let\tms@tempmac\tms@labellist%
    \expandafter\def%
      \expandafter\tms@labellist%
      \expandafter{%
      \tms@tempmac\or #1}%
  \fi%
    \next#2{}}
\def\tms@title{Timesheet}
\@settime\tms@start8:00{}
\@settime\tms@end17:00{}
\tms@minuteblocks=15%
\def\tms@blocklist{}%
\def\tms@label#1{\themonth\space\theday}%
\tms@groupblocks=4%
\newcalendar%
{timesheet}
{\cal@insert}
{7}
{\tms@blocks}
{1}
{&}
{G\tms@gettimes}
{\extrarowheight=3pt\tms@header}
{&\\\hline\end{longtable}%
 \iftms@landscape%
   \end{landscape}%
 \fi}%
{\cal@footer\newpage\cal@header}
{&%
 \ifnum\tms@groupblockcount<\tms@groupblocks%
  \\*\cline{1-4}%
  \global\advance\tms@groupblockcount by1\relax%
 \else%
  \\\hline%
  \global\tms@groupblockcount=1\relax%
 \fi%
 \tms@timecoltext}
{\dates@requiremonthtrue\dates@requiredaytrue}
{\message{^^JStart: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@date\cal@range@end%
  \caldate%
  \message{^^JEnd: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@date\cal@range@start%
  \caldate%
\relax%
\tms@blocks\tms@end%
\advance\tms@blocks by-\tms@start%
\divide\tms@blocks by\tms@minuteblocks%
  \def\tms@gettimes{%
    \ifcat$\tms@blocklist$%
      \tms@time@start\cal@group@count%
      \multiply\tms@time@start by\tms@minuteblocks%
      \global\advance\tms@time@start by\tms@start%
      \tms@time@end\tms@time@start%
      \global\advance\tms@time@end by\tms@minuteblocks%
    \else%
      \expandafter\tms@chopblock\tms@blocklist-,{}%
    \fi%
      \mod{60}\tms@time@start\tms@minutes@start%
      \tms@hours@start\dates@three%
      \divide\tms@hours@start by60%
      \mod{60}\tms@time@end\tms@minutes@end%
      \tms@hours@end\dates@three%
      \divide\tms@hours@end by60%
      \ifnum\tms@minutes@start<10%
        \edef\tms@minutes@start@mac{0\the\tms@minutes@start}%
      \else%
        \edef\tms@minutes@start@mac{\the\tms@minutes@start}%
      \fi%
      \ifnum\tms@minutes@end<10%
        \edef\tms@minutes@end@mac{0\the\tms@minutes@end}%
      \else%
        \edef\tms@minutes@end@mac{\the\tms@minutes@end}%
      \fi%
      \xdef\tms@timecoltext{%
        \noexpand\tms@timelabeltype{\the\tms@hours@start}&%
        \noexpand\tms@timelabeltype{\tms@minutes@start@mac}&%
        \noexpand\tms@timelabeltype{\the\tms@hours@end}&%
        \noexpand\tms@timelabeltype{\tms@minutes@end@mac}&}}%
\message{Package Timesheet: %
  setting table \the\tms@tablewidth\space in width.^^J}%
  \setlength{\tms@widthlessboxes}{2\arrayrulewidth}%
  \addtolength{\tms@widthlessboxes}{3\arrayrulewidth}%
  \addtolength{\tms@widthlessboxes}{\doublerulesep}%
  \addtolength{\tms@widthlessboxes}{6\tabcolsep}%
  \settowidth{\tms@numlen}{\tms@timelabeltype{99}}%
  \settowidth{\tms@colonlen}{\tms@timelabeltype{:}}%
  \settowidth{\tms@dashlen}{\tms@timelabeltype{\ --\ }}%
  \addtolength{\tms@widthlessboxes}{4\tms@numlen}%
  \addtolength{\tms@widthlessboxes}{2\tms@colonlen}%
  \addtolength{\tms@widthlessboxes}{\tms@dashlen}%
  \tms@tempcount\tms@leftprop%
  \advance\tms@tempcount by\tms@rightprop%
  \setlength{\tms@templen}{\tms@tablewidth}%
  \addtolength{\tms@templen}{-\tms@widthlessboxes}%
  \tms@leftlen\tms@templen%
  \divide\tms@leftlen by\tms@tempcount%
  \global\multiply\tms@leftlen by\tms@leftprop%
  \tms@rightlen\tms@templen%
  \divide\tms@rightlen by\tms@tempcount%
  \global\multiply\tms@rightlen by\tms@rightprop%
  \tms@tempcount\tms@days%
  \advance\tms@tempcount by1%
  \protected@edef\tms@header{%
    \noexpand\iftms@landscape%
      \noexpand\begin{landscape}%
    \noexpand\fi%
    \noexpand\begin{longtable}{%
      |>{\hfill}m{\the\tms@numlen}@{\tms@timelabeltype{:}}m{\the\tms@numlen}%
      @{\tms@timelabeltype{\ --\ }}%
      >{\hfill}m{\the\tms@numlen}@{\tms@timelabeltype{:}}m{\the\tms@numlen}%
      |%
      m{\the\tms@leftlen}||%
      m{\the\tms@rightlen}|}%
     \noexpand\multicolumn{6}{c}%
      {\tms@titletype{\noexpand\themonth\space%
                      \noexpand\theday,\space\noexpand\theyear}}%
     \\%
     \noexpand\multicolumn{4}{l}{}%
     &%
     \noexpand\multicolumn{1}{c}{\textbf{Plan}}&%
     \noexpand\multicolumn{1}{c}{\textbf{Action}}%
     \noexpand\\\noexpand\hline%
     \noexpand\endhead%
     \noexpand\tms@timecoltext}}
{\@newline[\smallskipamount]}%
{\cal@get@appointments[\tms@time@start/\tms@time@end]}%
{\relax%
  \ifnum\dates@time@start>0\relax%
    \ifnum\dates@time@start<\tms@time@start%
      \protected@edef\cal@entry@text{%
        \noexpand\tms@itemtype{%
          \noexpand$\noexpand<\noexpand$%
        \theshorttext, to \cal@appt@end@text%
        \noexpand$\noexpand>\noexpand$}}%
    \else%
      \ifnum\dates@time@start<\dates@time@end%
        \protected@edef\cal@entry@text{%
          \noexpand\tms@timeitemtype{%
            \cal@appt@start@text%
            --%
            \cal@appt@end@text}%
          \space%
          \noexpand\tms@itemtype{%
            \thelongtext}}%
      \else%
        \protected@edef\cal@entry@text{%
         \cal@appt@start@text%
          \space\thelongtext}%
      \fi%
    \fi%
  \fi}%
{\theappointments}
\message{Done loading style}
\endinput
%%
%% End of file `timesht.cls'.
