%%
%% This is file `timetabl.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% timetabl.dtx  (with options: `class')
%% This file is part of the Calendar package,
%% Copyright (C) 1996-1997 by Frank Bennett, Jr.
%% All rights reserved.
%% ------------------------------------------
\NeedsTeXFormat{LaTeX2e}[1995/06/01]
\ProvidesClass{timetabl}
          [1997/02/20 v1.0 Monthly calendar (Frank Bennett)]
\LoadClass[oneside]{article}
\newif\ifttbl@landscape
\newlength\ttbl@tablewidth
\newlength{\ttbl@hw}
\newlength{\ttbl@templen}
\newlength{\ttbl@widthlessboxes}
\newlength{\ttbl@timetextlen}
\newtoks\ttbl@tempreg@a
\newtoks\ttbl@tempreg@b
\newcount\ttbl@tempcount
\newcount\ttbl@start
\newcount\ttbl@end
\newcount\ttbl@minuteblocks
\newcount\ttbl@boxes
\newcount\ttbl@days
\newcount\ttbl@blocks
\newcount\ttbl@time@start
\newcount\ttbl@time@end
\newcount\ttbl@hours@start
\newcount\ttbl@minutes@start
\newcount\ttbl@hours@end
\newcount\ttbl@minutes@end
\newcount\ttbl@minute@base
\DeclareOption{a5paper}{\OptionNotUsed}
\DeclareOption{b5paper}{\OptionNotUsed}
\DeclareOption{legalpaper}{\OptionNotUsed}
\DeclareOption{executivepaper}{\OptionNotUsed}
\DeclareOption{twoside}{\OptionNotUsed}
\DeclareOption{titlepage}{\OptionNotUsed}
\DeclareOption{onecolumn}{\OptionNotUsed}
\DeclareOption{10pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{11pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{12pt}{\PassOptionsToPackage{\CurrentOption}{article}}
\DeclareOption{letterpaper}
   {\setlength\paperheight{11in}%
    \setlength\paperwidth{8.5in}%
    \def\ttbl@titletype#1{{\Large\textbf{#1}}}%
    \def\ttbl@labeltype#1{{\large\textbf{#1}}}%
    \def\ttbl@timelabeltype#1{\textbf{#1}}
    \def\ttbl@timeitemtype#1{{\large#1}}
    \def\ttbl@itemtype#1{{\small#1}}}
\DeclareOption{a4paper}
   {\setlength\paperheight{297mm}%
    \setlength\paperwidth{210mm}%
    \def\ttbl@titletype#1{{\Large\textbf{#1}}}%
    \def\ttbl@labeltype#1{{\large\textbf{#1}}}%
    \def\ttbl@timelabeltype#1{\textbf{#1}}
    \def\ttbl@timeitemtype#1{{\large#1}}
    \def\ttbl@itemtype#1{{\small#1}}}
\DeclareOption{a2paper}
   {\setlength\paperheight {420mm}%
    \setlength\paperwidth  {297mm}%
    \def\ttbl@titletype#1{{\Huge\textbf{#1}}}%
    \def\ttbl@labeltype#1{{\Large\textbf{#1}}}%
    \def\ttbl@timelabeltype#1{\large\textbf{#1}}
    \def\ttbl@timeitemtype#1{{\Large#1}}
    \def\ttbl@itemtype#1{#1}}
\DeclareOption{b4paper}
   {\setlength\paperheight{354mm}%
    \setlength\paperwidth{250mm}%
    \def\ttbl@titletype#1{{\Huge\textbf{#1}}}%
    \def\ttbl@labeltype#1{{\Large\textbf{#1}}}%
    \def\ttbl@timelabeltype#1{\large\textbf{#1}}
    \def\ttbl@timeitemtype#1{{\Large#1}}
    \def\ttbl@itemtype#1{#1}}
\DeclareOption{landscape}{\ttbl@landscapetrue}
\ExecuteOptions{a4paper}
\ProcessOptions
\pagestyle{empty}
\setlength{\headheight}{0pt}
\setlength{\headsep}{0pt}
\setlength{\topmargin}{-0.4in}
\setlength{\textheight}{\paperheight}
\addtolength{\textheight}{-1.2in}
\setlength{\marginparwidth}{0pt}
\setlength{\marginparsep}{0pt}
\setlength{\oddsidemargin}{-0.4in}
\setlength{\textwidth}{\paperwidth}
\addtolength{\textwidth}{-1.2in}
\ifttbl@landscape
  \setlength{\ttbl@tablewidth}{\textheight}%
\else
  \setlength{\ttbl@tablewidth}{\textwidth}%
\fi
\RequirePackage{longtable}
\RequirePackage{array}[1996/06/14]
\RequirePackage{rotating}
\RequirePackage{calendar}
\RequirePackage{keyval}
\RequirePackage{lscape}
\tracingdates=0%
\define@key{cal@options}{leftspace}{\setlength{\LTleft}{#1}}
\define@key{cal@options}{rightspace}{\setlength{\LTright}{#1}}
\define@key{cal@options}{width}{\setlength{\ttbl@tablewidth}{#1}}
\define@key{cal@options}{title}{\def\ttbl@title{#1}}
\define@key{cal@options}{start}{\@settime\ttbl@start#1{}}
\define@key{cal@options}{end}{\@settime\ttbl@end#1{}}
\define@key{cal@options}{blockminutes}{\ttbl@minuteblocks=#1}
\define@key{cal@options}{blocks}{\@setblocks#1,,{}}
\define@key{cal@options}{labels}{\@extractlabels#1,,{}}
\def\@settime#1#2:#3#{%
  \ttbl@tempcount=#2%
  \multiply\ttbl@tempcount by60%
  \advance\ttbl@tempcount by#3%
  \global#1\ttbl@tempcount}
\def\@splitblocks#1-#2#{%
  \def\@blockstarttext{#1}%
  \def\@blockendtext{#2}}
\def\@setblocks#1,#2#{%
  \ifcat$#1$%
    \let\next\@gobble%
  \else%
    \let\next\@setblocks%
    \global\advance\ttbl@blocks by 1%
    \@splitblocks#1{}%
    \expandafter\@settime%
      \expandafter\ttbl@time@start\@blockstarttext{}%
    \expandafter\@settime%
      \expandafter\ttbl@time@end\@blockendtext{}%
    \let\ttbl@tempmac\ttbl@blocklist%
    \edef\ttbl@blocklist{%
      \ttbl@tempmac\the\ttbl@time@start-\the\ttbl@time@end,}%
  \fi%
    \next#2{}}
\def\ttbl@chopblock#1-#2,#3#{%
  \global\ttbl@time@start=#1%
  \global\ttbl@time@end=#2%
  \gdef\ttbl@blocklist{#3}}%
\def\ttbl@labellist{}%
\def\@extractlabels#1,#2#{%
  \ifcat$#1$%
    \ttbl@tempreg@a=\expandafter{\ttbl@labellist}%
    \edef\ttbl@label##1{%
      \noexpand\ifcase##1\the\ttbl@tempreg@a\noexpand\fi}%
    \let\next\@gobble%
  \else%
    \let\next\@extractlabels%
    \let\ttbl@tempmac\ttbl@labellist%
    \expandafter\def%
      \expandafter\ttbl@labellist%
      \expandafter{%
      \ttbl@tempmac\or #1}%
  \fi%
    \next#2{}}
\def\ttbl@title{Conference Schedule}
\@settime\ttbl@start8:00{}
\@settime\ttbl@end17:00{}
\ttbl@minuteblocks=60%
\def\ttbl@blocklist{}%
\def\ttbl@label#1{\themonth\space\theday}%
\newcalendar%
{timetable}
{\cal@insert}
{7}
{\ttbl@boxes}
{\ttbl@days}
{&}
{z\ttbl@gettimes}
{\extrarowheight=3pt\ttbl@header}
{\\\hline\end{longtable}%
 \ifttbl@landscape%
   \end{landscape}%
 \fi}%
{\cal@footer\newpage\cal@header}
{\\\hline\ttbl@timecoltext}
{\dates@requiremonthtrue\dates@requiredaytrue}
{\message{^^JStart: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@date\cal@range@end%
  \caldate%
  \message{^^JEnd: \theshortweekday\space%
    \theday\space\theshortmonth\space\theyear}%
  \dates@date\cal@range@start%
  \caldate%
  \ttbl@days\cal@range@end%
  \advance\ttbl@days by-\cal@range@start%
  \advance\ttbl@days by1%
\ifcat$\ttbl@blocklist$%
  \ttbl@blocks\ttbl@end%
  \advance\ttbl@blocks by-\ttbl@start%
  \divide\ttbl@blocks by\ttbl@minuteblocks%
\fi%
\ttbl@boxes\ttbl@blocks%
\multiply\ttbl@boxes by\ttbl@days%
  \def\ttbl@gettimes{%
    \ifcat$\ttbl@blocklist$%
      \ttbl@time@start\cal@group@count%
      \divide\ttbl@time@start by\ttbl@days%
      \multiply\ttbl@time@start by\ttbl@minuteblocks%
      \global\advance\ttbl@time@start by\ttbl@start%
      \ttbl@time@end\ttbl@time@start%
      \global\advance\ttbl@time@end by\ttbl@minuteblocks%
    \else%
      \expandafter\ttbl@chopblock\ttbl@blocklist-,{}%
    \fi%
      \mod{60}\ttbl@time@start\ttbl@minutes@start%
      \ttbl@hours@start\dates@three%
      \divide\ttbl@hours@start by60%
      \mod{60}\ttbl@time@end\ttbl@minutes@end%
      \ttbl@hours@end\dates@three%
      \divide\ttbl@hours@end by60%
      \ifnum\ttbl@minutes@start<10%
        \edef\ttbl@minutes@start@mac{0\the\ttbl@minutes@start}%
      \else%
        \edef\ttbl@minutes@start@mac{\the\ttbl@minutes@start}%
      \fi%
      \ifnum\ttbl@minutes@end<10%
        \edef\ttbl@minutes@end@mac{0\the\ttbl@minutes@end}%
      \else%
        \edef\ttbl@minutes@end@mac{\the\ttbl@minutes@end}%
      \fi%
      \xdef\ttbl@timecoltext{%
        \noexpand\vbox{\vfil\vskip4pt%
        \noexpand\begin{sideways}%
        \noexpand\ttbl@timelabeltype{%
          \the\ttbl@hours@end:\ttbl@minutes@end@mac%
        $\noexpand\leftarrow$%
        \the\ttbl@hours@start:\ttbl@minutes@start@mac}%
        \noexpand\end{sideways}%
        \vfil}
      &}}%
\message{Package Timetable: %
  setting table \the\ttbl@tablewidth\space in width.^^J}%
  \setlength{\ttbl@widthlessboxes}{2\arrayrulewidth}%
  \addtolength{\ttbl@widthlessboxes}{\ttbl@days\arrayrulewidth}%
  \addtolength{\ttbl@widthlessboxes}{2\tabcolsep}%
  \setlength{\ttbl@templen}{2\tabcolsep}%
  \addtolength{\ttbl@widthlessboxes}{\ttbl@days\ttbl@templen}%
  \settoheight{\ttbl@timetextlen}{\ttbl@timelabeltype{99:99--99:99}}%
  \settodepth{\ttbl@templen}{\ttbl@timelabeltype{99:99--99:99}}%
  \addtolength{\ttbl@timetextlen}{\ttbl@templen}%
  \addtolength{\ttbl@widthlessboxes}{\ttbl@timetextlen}%
  \setlength{\ttbl@hw}{\ttbl@tablewidth}%
  \addtolength{\ttbl@hw}{-\ttbl@widthlessboxes}%
  \divide\ttbl@hw by\ttbl@days%
\edef\ttbl@firstunit{%
  m{\the\ttbl@timetextlen}%
  \noexpand|}%
\ttbl@tempreg@a=\expandafter{\expandafter|\ttbl@firstunit}%
\edef\ttbl@dayunit{%
  m{\the\ttbl@hw}%
  \noexpand|}%
\ttbl@tempreg@b=\expandafter{\ttbl@dayunit}%
\ttbl@tempcount=1%
\loop%
 \edef\ttbl@tempmac{\the\ttbl@tempreg@a\the\ttbl@tempreg@b}%
 \ttbl@tempreg@a=\expandafter{\ttbl@tempmac}%
\ifnum\ttbl@tempcount<\ttbl@days%
  \advance\ttbl@tempcount by1%
\repeat%
  \def\ttbl@labeltext{}%
  \dates@date=\cal@range@start%
  \caldate%
  \ttbl@tempcount=1%
  \ttbl@tempreg@b={}%
  \loop%
   \edef\ttbl@labeltext{\the\ttbl@tempreg@b&%
     \noexpand\multicolumn{1}{c|}{%
       \noexpand\ttbl@labeltype{%
          \ttbl@label{\ttbl@tempcount}}}}%
   \ttbl@tempreg@b=\expandafter{\ttbl@labeltext}%
  \ifnum\dates@date<\cal@range@end%
    \advance\dates@date by1%
    \caldate%
    \advance\ttbl@tempcount by1%
  \repeat%
  \dates@date\cal@range@start%
  \caldate%
  \ttbl@tempcount\ttbl@days%
  \advance\ttbl@tempcount by1%
  \protected@edef\ttbl@header{%
    \noexpand\ifttbl@landscape%
      \noexpand\begin{landscape}%
    \noexpand\fi%
    \noexpand\begin{longtable}{\the\ttbl@tempreg@a}%
    \noexpand\multicolumn{\ttbl@tempcount}{c}%
      {\noexpand\ttbl@titletype{\ttbl@title}}%
    \noexpand\\\noexpand\hline%
    \the\ttbl@tempreg@b\noexpand\\\noexpand\hline\noexpand\hline%
      \noexpand\endhead%
    \noexpand\ttbl@timecoltext}}%
{\@newline[\medskipamount]}%
{\cal@get@appointments[\ttbl@time@start/\ttbl@time@end]}%
{\relax%
  \ifnum\dates@time@start>0\relax%
    \ifnum\dates@time@start<\ttbl@time@start%
      \protected@edef\cal@entry@text{%
        \noexpand\ttbl@itemtype{%
          \noexpand$\noexpand<\noexpand$%
        \theshorttext, to \cal@appt@end@text%
        \noexpand$\noexpand>\noexpand$}}%
    \else%
      \ifnum\dates@time@start<\dates@time@end%
        \protected@edef\cal@entry@text{%
          \noexpand\ttbl@timeitemtype{%
            \cal@appt@start@text%
            --%
            \cal@appt@end@text}%
          \space%
          \noexpand\ttbl@itemtype{%
            \thelongtext}}%
      \else%
        \protected@edef\cal@entry@text{%
         \cal@appt@start@text%
          \space\thelongtext}%
      \fi%
    \fi%
  \fi}%
{\theappointments}

\endinput
%%
%% End of file `timetabl.cls'.
