%%
%% This is file `ltugproc.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% tugboat.dtx  (with options: `ltugproccls')
%% 
%% Copyright (C) 1994,1995,1996 TeX Users Group
%% All rights reserved.
%% 
%% This file is part of the Tugboat package.
%% -----------------------------------------
%% 
%% This is a generated file.  Permission is granted to customize the
%% declarations in this file to serve the needs of your installation.
%% However, no permission is granted to distribute a modified version of
%% this file under its original name.
%% 
%% 
\NeedsTeXFormat{LaTeX2e}[1994/12/01]
\ProvidesClass  {ltugproc}
                   [1997/05/31 v1.4i
                       TUG conference proceedings class%
                   ]
\def\@tugclass{ltugproc}
\newif\if@proctw@column  \@proctw@columntrue
\DeclareOption{onecolumn}{\@proctw@columnfalse}
\newif\if@proc@sober
\DeclareOption{tug95}{\@proc@soberfalse}
\DeclareOption{tug96}{\@proc@sobertrue}
\expandafter\let\csname ds@tug97\expandafter\endcsname
  \csname ds@tug96\endcsname
\DeclareOption{tugproc}{%
  \ClassWarning{ltugproc}{Option \CurrentOption\space ignored}%
}
\DeclareOption{numbersec}{\ds@tugproc}
\DeclareOption{nonumber}{\ds@tugproc}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{ltugboat}}
\InputIfFileExists{ltugproc.cfg}{\ClassInfo{ltugproc}%
           {Loading ltugproc configuration information}}{}
\@tempcnta\year
\divide\@tempcnta by100
\multiply\@tempcnta by100
\advance\@tempcnta-\year
\@tempcnta-\@tempcnta
\edef\@tempa{\noexpand\providecommand\noexpand\tugProcYear
                {\ifnum10>\@tempcnta0\fi\the\@tempcnta}}
\@tempa
\ClassInfo{ltugproc}{Proceedings defined for year
  \expandafter\ifnum\tugProcYear<70\relax20\else
    \expandafter\ifnum\tugProcYear>100\else19\fi\fi\tugProcYear}
\expandafter\ifx\csname ds@tug\tugProcYear\endcsname\relax
  \def\tugProcYear{96}\fi
\ExecuteOptions{tug\tugProcYear}
\ProcessOptions
\LoadClass{ltugboat}
\def\maketitle{%
 \setcounter{footnote}{0}%
 \def\thefootnote{\fnsymbol{footnote}}%
 \if@proctw@column \twocolumn[\@maketitle]%
 \else             \onecolumn\@maketitle
 \fi
 \def\thefootnote{\arabic{footnote}}%
 \setcounter{footnote}{0}%
  }
\def\@TB@test@document{%
  \edef\@tempa{\the\everypar}
  \def \@tempb{\@nodocument}
  \ifx \@tempa\@tempb
    \@nodocument
  \fi
}
\def\AUTHORfont {\large\rmfamily\mdseries\upshape}
\def\TITLEfont  {\Large\rmfamily\mdseries\upshape}
\def\addressfont{\small\rmfamily\mdseries\upshape}
\def\netaddrfont{\small\ttfamily\mdseries\upshape}
\def\@maketitle{%
   {\parskip\z@
    \TITLEfont\raggedright\noindent\@title\par
      \count@=0
      \loop
      \ifnum\count@<\authornumber
        \vskip20\p@
        \advance\count@\@ne
        {\AUTHORfont\theauthor{\number\count@}\endgraf}%
        \addressfont\theaddress{\number\count@}\endgraf
        {%
          \allowhyphens
          \hangindent1.5pc
          \netaddrfont\thenetaddress{\number\count@}\endgraf
          \hangindent1.5pc
          \thePersonalURL{\number\count@}\endgraf
        }%
      \repeat
   \vskip20\p@}%
   \if@abstract
      \centerline{\bfseries Abstract}%
      \vskip.5\baselineskip\rmfamily
      \list{}{\listparindent20\p@
         \itemindent\z@ \leftmargin4.875pc
         \rightmargin\leftmargin \parsep \z@}\item[]\ignorespaces
            \the\abstract@toks
      \endlist\global\@ignoretrue
   \fi
   \vskip1pc
   \xdef\@titlepagenum{\number\c@page}%
   \global\@afterindentfalse\aftergroup\@afterheading
  }

\def\@titlepagenum{1 }          % default
\def\thanks#1{\@bsphack\TBWarning{\string\thanks\space
              is not supported}\@esphack}
\newtoks\abstract@toks  \abstract@toks{}
\let\if@abstract\iffalse
\def\abstract{\def\@abstract@{abstract}%
  \ifx\@currenvir\@abstract@
  \else
    \TBError{\string\abstract\space is illegal:%
      \MessageBreak
      use \string\begin{\@abstract@} instead}%
      {\@abstract@\space may only be used as an environment}
  \fi
  \global\let\if@abstract\iftrue
  {\ifnum0=`}\fi
  \@abstract@getbody}
\let\endabstract\relax
\long\def\@abstract@getbody#1\end{%
  \global\abstract@toks\expandafter{\the\abstract@toks#1}%
  \@abstract@findend}
\def\@abstract@findend#1{%
  \def\@tempa{#1}%
  \ifx\@tempa\@abstract@
    \expandafter\@abstract@end
  \else
    \def\@tempb{document}%
    \ifx\@tempa\@tempb
      \TBError{\string\begin{\@abstract@}
          ended by \string\end{\@tempb}}%
        {You've forgotten \string\end{\@abstract@}}
    \else
       \global\abstract@toks\expandafter{\the\abstract@toks\end{#1}}%
       \expandafter\expandafter\expandafter\@abstract@getbody
    \fi
  \fi}
\def\@abstract@end{\ifnum0=`{\fi}%
  \expandafter\end\expandafter{\@abstract@}}
\renewcommand{\signature}{\TBWarning
         {\string\signature\space is invalid in proceedings issues}}
\def\rhTitle{\@title}
\def\shortTitle #1{\def\rhTitle{#1}}
\def\rhAuthor{\@author}
\def\shortAuthor #1{\def\rhAuthor{#1}}
\def\@oddhead{\MakeRegistrationMarks
  \ifnum\c@page=\@titlepagenum
  \else
    {%
      \hfil
      \def\\{\unskip\ \ignorespaces}%
      \rmfamily\rhTitle
    }%
  \fi}
\def\@evenhead{\MakeRegistrationMarks
  \ifnum\c@page=\@titlepagenum
  \else
    {%
      \def\\{\unskip\ \ignorespaces}%
      \rmfamily\rhAuthor
      \hfil
    }%
  \fi}

\advance\footskip8\p@    % for deeper running feet

\def\dopagecommands{\csname @@pagecommands\number\c@page\endcsname}
\def\setpagecommands#1#2{\expandafter\def\csname @@pagecommands#1\endcsname
  {#2}}
\def\@oddfoot{\ifpreprint\pfoottext\hfil\Now\hfil\thepage
        \else\rfoottext\hfil\thepage\fi\dopagecommands}
\def\@evenfoot{\ifpreprint\thepage\hfil\Now\hfil\pfoottext
        \else\thepage\hfil\rfoottext\fi\dopagecommands}

\def\pfoottext{{\smc Preprint}: Proceedings of the \volyr{} Annual Meeting}
\def\rfoottext{\normalfont\TUB, \volx\Dash
   {Proceedings of the \volyr{} Annual Meeting}}
\setcounter{secnumdepth}{0}
\if@proc@sober
  \def\section
         {\TB@nolimelabel
          \TB@startsection{{section}%
                           1%
                           \z@%
                           {-8\p@}%
                           {6\p@}%
                           {\normalsize\bf\raggedright}}}
\else
  \def\section
         {\TB@nolimelabel
          \TB@startsection{{section}%
                           1%
                           \z@%
                           {-8\p@}%
                           {6\p@}%
                           {\large\bf\raggedright}}}
\fi
\def\subsection
         {\TB@nolimelabel
          \TB@startsection{{subsection}%
                           2%
                           \z@%
                           {6\p@\@plus 2\p@\@minus2\p@}%
                           {-5\p@\@plus -\fontdimen3\the\font}%
                           {\normalsize\bf}}}
\def\subsubsection
         {\TB@nolimelabel
          \TB@startsection{{subsubsection}%
                           3%
                           \z@%
                           {1sp}%
                           {-5\p@\@plus -\fontdimen3\the\font}%
                           {\normalsize\bf}}}
\renewcommand\appendix{\par
  \renewcommand\thesection{\@Alph\c@section}%
  \setcounter{section}{0}%
  \setcounter{secnumdepth}{1}%
  \def\@tempa{appendix}
  \ifx\@tempa\@currenvir
    \expandafter\@appendix@env
  \fi
}
\newcommand\app@prefix@section{}
\newcommand\@appendix@env[1][Appendix]{%
  \renewcommand\@seccntformat[1]{\csname app@prefix@##1\endcsname
    \csname the##1\endcsname\quad}%
  \renewcommand\app@prefix@section{#1 }%
}
\let\endappendix\relax
\endinput
%%
%% End of file `ltugproc.cls'.
