%%% LaTeX class na pisanie slovenskych osobnych listov.
%%%
%%% (C) Vladislav Kurz 2002-2003, vladki@email.cz
%%%
%%% Tento program je distribuovany podla GNU General Public License.
%%% Presne znenie GNU GPL najdete na http://www.gnu.org/ neoficialny
%%% preklad do slovenciny na http://www.gnu.sk/
%%% 
%%% Vytvorene podla normy STN 01 6910 Pravidla pisania a upravy pisomnosti
%%% Pretoze norma je pisana s ohladom na pisaci stroj, su niektore veci inak.
%%% Podciarkovanie je nahradene tucnym, okraje su ponechane LaTeXove
%%% a mozno aj ine veci su ponechane inak ako v norme,  pretoze som ich bud
%%% nepotreboval, alebo mi pripadali ako typograficky nezmysel.
%%% Class je na listy typu osoba->urad. Listy z firiem a uradov by este
%%% mali mat dalsie nalezitosti (nasa znacka, vasa znacka, vybavuje,...)

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{list-o}
\LoadClass[a4paper]{letter}
\RequirePackage{slovak}

%%% Nasledujuci blok nastavi pravy, lavy a horny okraj na 1 palec (2,54 cm)
%\setlength{\headheight}{0pt}
%\setlength{\headsep}{0pt}
%\setlength{\topmargin}{0pt}
%\setlength{\oddsidemargin}{0pt}
%\setlength{\textwidth}{\paperwidth}
%\addtolength{\textwidth}{-2in}

%%% Prikazom subject urcime co ma byt vytlacene v hlavicke z slovom Vec:
\newcommand*{\subject}[1]{\def\lettersubject{#1}}
\subject{}

%%% Zaciatok listu:
% \documentclass{list-o}
% \name{Meno Priezvisko}					%% odosielatel
% \address{Ulica cislo, PSC Mesto, tel/fax: ...}		%% odosielatel
% \location{Miesto}	
% \date{Datum}	
% \begin{document}
% \begin{letter}{Meno Priezvisko\\Ulica cislo\\PSC Mesto}	%% adresat
% \subject{Ziadost o pridel sucheho chleba}
% \opening{Vazeny pan uradnik,}	

%%% Norma prikazuje rozdelit PSC medzerou a za PSC dat dve medzery.
%%% Ja radsej pisem psc so zuzenou medzerou napr. 917\,08 Trnava.
%%% Telefonne cisla tiez rozdelujem na dvojice/trojice zuzenou medzerou.

\renewcommand{\opening}[1]{\thispagestyle{empty}
	\noindent\textbf{\fromname, \fromaddress}\par\vspace{2\parskip}
	\noindent\toname\\\toaddress\par\vspace{2\parskip}
	\noindent\hfill\fromlocation\ \@date\par\vspace{1\parskip}
	\noindent\textbf{\lettersubject}\par\vspace{1\parskip}
	\noindent#1\par\nobreak
}

%%% Koniec listu
% \closing{So sudruzskym pozdravom}
%%% Zoznam priloh
% \encl{Zemiaky}
% \encl{Knedla}
% \encl{Ryza}
% ...
%%% Definitivny koniec
% \end{letter}
% \end{document}

\renewcommand{\closing}[1]{\par\stopbreaks
	\noindent\raggedright #1\par\vspace{4\parskip}
}

\renewcommand{\encl}[1]{\par
	\noindent\textbf{\enclname}\\
	\noindent #1\par
}

%%% Zrusime vertikalne centrovanie jednostrankovych listov
\let\@texttop\relax

\endinput
